#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using PrototypeHelperLibrary;
#endregion

namespace MissileSwarmDodgingPrototype.World
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class SteeringModel : SteeringObject
    {
        protected bool m_bDestroyed = false;
        protected SimpleModel m_Model;

        public SteeringModel(Game game)
            : base(game)
        {
            m_Model = new SimpleModel(game);
            game.Components.Add(m_Model);
        }

        public void Destroy()
        {
            m_bDestroyed = true;
            Game.Components.Remove(m_Model);
            Game.Components.Remove(this);
        }

        public bool IsDestroyed
        {
            get
            {
                return m_bDestroyed;
            }
        }

        public SimpleModel Model
        {
            get
            {
                return m_Model;
            }
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);

            m_Model.Position = m_Position;
        }
    }
}


